class XC_CreatureCarcass extends CreatureCarcass abstract;

function Tw_Destroyed()
{
	if ( !bDecorative )
		DeathZone.NumCarcasses--;
	if ( Bugs != None )
		Bugs.LifeSpan = 5.00;
	Super(Carcass).Destroyed();
}

function Tw_Initfor(actor Other)
{
	local rotator carcRotation;
	local int i;
//	local string Tmp;
//	local class<Actor> XC_Class;
//	local Actor XM;

	if (Other == None)
	{
		Destroy();
		GoTo StopHere;
	}
/*
	bHidden=True;
	SetCollision(False,False,False);
	Destroy();
	if ( ScriptedPawn(Other) != None )
		ScriptedPawn(Other).CarcassType = Class'ExCreatureCarcass';
	Spawn(class'ExCreatureCarcass').InitFor(Other);
	GoTo StopHere;
*/
	if ( bDecorative)
	{
		DeathZone = Region.Zone;
		if (DeathZone != None)
			DeathZone.NumCarcasses++;
	}
	bDecorative = false;
	bMeshCurvy = Other.bMeshCurvy;
	bMeshEnviroMap = Other.bMeshEnviroMap;
	for (i=0;i<8;i++) //NEED THIS!
		multiskins[i]=other.multiskins[i];
	Mesh = Other.Mesh;
	Skin = Other.Skin;
	if (skin!=none)
		skin.lodset=lodset_skin;
	Texture = Other.Texture;
	if (texture!=none)
		texture.lodset=lodset_skin;
	Fatness = Other.Fatness;
	DrawScale = Other.DrawScale;
	SetCollisionSize(Other.CollisionRadius + 4, Other.CollisionHeight);
	if ( !SetLocation(Location) )
		SetCollisionSize(CollisionRadius - 4, CollisionHeight);
	if ( Scriptedpawn(Other) != None )
	{
		bgreenblood=ScriptedPawn(Other).bGreenBlood;
		lifespan=40;
	}
	DesiredRotation = other.Rotation;
	DesiredRotation.Roll = 0;
	DesiredRotation.Pitch = 0;
	AnimSequence = Other.AnimSequence;
	AnimFrame = Other.AnimFrame;
	AnimRate = Other.AnimRate;
	TweenRate = Other.TweenRate;
	AnimMinRate = Other.AnimMinRate;
	AnimLast = Other.AnimLast;
	bAnimLoop = Other.bAnimLoop;
	SimAnim.X = 10000 * AnimFrame;
	SimAnim.Y = 5000 * AnimRate;
	SimAnim.Z = 5000 * TweenRate;
	SimAnim.W = 10000 * AnimLast;
	bAnimFinished = Other.bAnimFinished;
	Velocity = other.Velocity;
	Mass = Other.Mass;
	if ( Buoyancy < 0.8 * Mass )
		Buoyancy = 0.9 * Mass;
	if ( AnimSequence == 'LeglessDeath' ) 	//krall
		SetCollision(true, false, false);
/*
	XC_Class=class<Actor>( DynamicLoadObject( "XC_Engine.XC_PrimitiveMesh", class'Class' ) );
	if ( XC_Class != None )
	{
		Tag = Self.Name;
		XM = Spawn(XC_Class,,Tag,Location);
		if ( XM != None )
		{
//			log ( "I have Tag >>"@XM.Tag );
			XM.Attach(Self);
		}
	}
*/
StopHere:
}

function Tw_AddFliesAndRats()
{
	if ( (flies > 0) && (Bugs == None) )
	{
		Bugs = Spawn(class 'DeadBodySwarm');
		if (Bugs != None)
		{
			Bugs.SetBase(Self);
			DeadBodySwarm(Bugs).swarmsize = flies * (FRand() + 0.9);
			DeadBodySwarm(Bugs).swarmradius = collisionradius;
		}
	}
}

function Tw_LieStill()
{
	SimAnim.X = 10000 * AnimFrame;
	SimAnim.Y = 5000 * AnimRate;
	if ( !bThumped && !bDecorative )
		LandThump();
	if ( !bReducedHeight )
		ReduceCylinder();
}

/*
function CreateReplacement()
{
	local CreatureChunks carc;

	if (bHidden)
		return;
	if ( bodyparts[0] != None )
		carc = Spawn(class 'CreatureChunks',,, Location + ZOffset[0] * CollisionHeight * vect(0,0,1)); 
	if (carc != None)
	{
		carc.TrailSize = Trails[0];
		carc.Mesh = bodyparts[0];
		carc.bMasterChunk = true;
		carc.Initfor(self);
		carc.Bugs = Bugs;
		if ( Bugs != None )
			Bugs.SetBase(carc);
		Bugs = None;
	}
	else if ( Bugs != None )
		Bugs.Destroy();
}
*/

function Tw_ReduceCylinder()
{
	local float OldHeight;

	RemoteRole=ROLE_DumbProxy;
	bReducedHeight = true;
	SetCollision(bCollideActors,False,False);
	if ( Mesh == LodMesh'UnrealI.KrallM' )
		OldHeight = CollisionHeight/3;
	else
		OldHeight = CollisionHeight;
	if ( ReducedHeightFactor < Default.ReducedHeightFactor )
		SetCollisionSize(CollisionRadius, CollisionHeight * ReducedHeightFactor);
	else
		SetCollisionSize(CollisionRadius + 4, CollisionHeight * ReducedHeightFactor);
	PrePivot = vect(0,0,1) * (OldHeight - CollisionHeight);
	if ( !SetLocation(Location - PrePivot) )
	{
		SetCollisionSize(CollisionRadius - 4, CollisionHeight);
		if ( !SetLocation(Location - PrePivot) )
		{
			SetCollisionSize(CollisionRadius, OldHeight );
			SetCollision(false, false, false);
			PrePivot = vect(0,0,0);
		}
	}
	PrePivot = PrePivot + vect(0,0,2);
	Mass = Mass * 0.8;
	Buoyancy = Buoyancy * 0.8;
}

function Tw_GibSound()
{
	local float decision;

	decision = FRand();
	if (decision < 0.2)
		PlaySound(GibOne, SLOT_Interact, 0.1 * Mass);
	else if ( decision < 0.35 )
		PlaySound(GibTwo, SLOT_Interact, 0.1 * Mass);
	else if ( decision < 0.5 )
		PlaySound(sound'Gib3', SLOT_Interact, 0.1 * Mass);
	else if ( decision < 0.8 )
		PlaySound(sound'Gib4', SLOT_Interact, 0.1 * Mass);
	else 
		PlaySound(sound'Gib5', SLOT_Interact, 0.1 * Mass);
	}

defaultproperties
{
}
