class XC_DeathMatchPlus expands DeathMatchPlus abstract;

function Tw_ChangeName ( Pawn Other, string S, bool bNameChange )
{
	local pawn APlayer;

	if ( S == "" )
		GoTo NoChanges;

	S = left(S,24);
	if ( Other.PlayerReplicationInfo != None && Other.PlayerReplicationInfo.PlayerName ~= S )
		GoTo NoChanges;

	APlayer = Level.PawnList;

	While ( APlayer != None )
	{
		if ( APlayer.PlayerReplicationInfo != None && APlayer.PlayerReplicationInfo.PlayerName ~= S )
		{
			Other.ClientMessage(S$NoNameChange);
			return;
		}
		APlayer = APlayer.NextPawn;
	}

	if ( Other.PlayerReplicationInfo != None )
	{
		Other.PlayerReplicationInfo.OldName = Other.PlayerReplicationInfo.PlayerName;
		Other.PlayerReplicationInfo.PlayerName = S;
		if ( bNameChange && !Other.IsA('Spectator') )
			BroadcastLocalizedMessage( DMMessageClass, 2, Other.PlayerReplicationInfo );

		if (LocalLog != None)
			LocalLog.LogNameChange(Other);
		if (WorldLog != None)
			WorldLog.LogNameChange(Other);
	}
NoChanges:
}
