class XC_Eightball expands Eightball abstract;

function Tw_AltFireTick( float DeltaTime )
{
	if ( Pawn(Owner) != None && Pawn(Owner).Health > 0 && !bDeleteMe )
	{
		if( (pawn(Owner).bAltFire==0) || (RocketsLoaded > 5) )  // If if Fire button down, load up another
			GoToState('FireRockets');
	}
}

function Tw_FireTick( float DeltaTime )
{
	if ( bDeleteMe || Pawn(Owner) == None )
		Goto NoTick;
	if ( Pawn(Owner) != None && Pawn(Owner).Health > 0 )
	if ( (PlayerPawn(Owner) == None) && ((Pawn(Owner).MoveTarget != None && Pawn(Owner).Target != None
	&& Pawn(Owner).MoveTarget != Pawn(Owner).Target) 
			|| (Pawn(Owner).Enemy == None)
			|| ( Mover(Owner.Base) != None )
			|| ((Owner.Physics == PHYS_Falling) && (Owner.Velocity.Z < 15))
			|| (VSize(Owner.Location - Pawn(Owner).Target.Location) < 400)
			|| !Pawn(Owner).CheckFutureSight(0.15)) )
		Pawn(Owner).bFire = 0;
		if( pawn(Owner).bFire==0 || RocketsLoaded > 5)  // If Fire button down, load up another
			GoToState('FireRockets');
NoTick:
}

	function Tw_BeginState()
	{
		local vector FireLocation, StartLoc, X,Y,Z;
		local rotator FireRot;
		local ExRocket r;
		local grenade g;
		local float Angle;
		local pawn BestTarget;
		local int DupRockets;

		Angle = 0;
		DupRockets = RocketsLoaded - 1;
		if (DupRockets < 0) DupRockets = 0;
		if ( PlayerPawn(Owner) != None )
		{
			PlayerPawn(Owner).shakeview(ShakeTime, ShakeMag*RocketsLoaded, ShakeVert); //shake player view
			PlayerPawn(Owner).ClientInstantFlash( -0.4, vect(650, 450, 190));
		}
		else
			bTightWad = ( FRand() * 4 < Pawn(Owner).skill );

		GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);
		StartLoc = Owner.Location + CalcDrawOffset(); 
		FireLocation = StartLoc + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z; 
		if ( bFireLoad )
			AdjustedAim = pawn(owner).AdjustAim(ProjectileSpeed, FireLocation, AimError, True, bWarnTarget);
		else 
			AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, FireLocation, AimError, True, bAltWarnTarget);	

		if ( PlayerPawn(Owner) != None )
			AdjustedAim = Pawn(Owner).ViewRotation;

		PlayAnim( 'Fire', 0.6, 0.05);
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		if ( (LockedTarget!=None) || !bFireLoad )
		{
			BestTarget = Pawn(CheckTarget());
			if ( (LockedTarget!=None) && (LockedTarget != BestTarget) ) 
			{
				LockedTarget = None;
				bLockedOn=False;
			}
		}
		else 
			BestTarget = None;
		bPointing = true;
		FireRot = AdjustedAim;
		RocketRad = 4;
		if (bTightWad || !bFireLoad) RocketRad=7;
		While ( RocketsLoaded > 0 )
		{
			Firelocation = StartLoc - Sin(Angle)*Y*RocketRad + (Cos(Angle)*RocketRad - 10.78)*Z + X * (10 + 8 * FRand());
			if (bFireLoad)
			{
				if ( Angle > 0 )
				{
					if ( Angle < 3 && !bTightWad)
						FireRot.Yaw = AdjustedAim.Yaw - Angle * 600;
					else if ( Angle > 3.5 && !bTightWad)
						FireRot.Yaw = AdjustedAim.Yaw + (Angle - 3)  * 600;
					else
						FireRot.Yaw = AdjustedAim.Yaw;
				}
				if ( LockedTarget!=None )
				{
					r = Spawn( class 'ExSeekingRocket',, '', FireLocation,FireRot);
					if ( ExSeekingRocket(r) != None)
					{
						ExSeekingRocket(r).Seeking = LockedTarget;
						r.NumExtraRockets = DupRockets;
					}
				}
				else 
				{
					r = Spawn( class 'ExRocket',, '', FireLocation,FireRot);
					if ( r != None )
					{
						r.NumExtraRockets = DupRockets;
						if (RocketsLoaded>5 && bTightWad) r.bRing=True;
					}
				}
				if (r != None)
					if ( Angle > 0 )
						r.Velocity *= (0.9 + 0.2 * FRand());
			}
			else 
			{
				g = Spawn( class 'Grenade',, '', FireLocation,AdjustedAim);
				if ( g != None )
				{
					g.WarnTarget = ScriptedPawn(BestTarget);
					g.NumExtraGrenades = DupRockets;
				}
				if ( Owner != None )
					Owner.PlaySound(AltFireSound, SLOT_None, 3.0*Pawn(Owner).SoundDampening);
			}

			Angle += 1.0484; //2*3.1415/6;
			RocketsLoaded--;
		}
		bTightWad=False;
		//bFireMem = false;
		//bAltFireMem = false;
	}