class XC_GiantGasbag expands GiantGasbag abstract;

function SpawnBelch()
{
	local Gasbag G;
	local vector X,Y,Z, projStart;
	local actor P;
	 
	GetAxes(Rotation,X,Y,Z);
	projStart = Location + 0.5 * CollisionRadius * X - 0.3 * CollisionHeight * Z;
	if ( (numChildren > 1) || (FRand() > 0.2) )
	{
		if ( Caps(String(RangedProjectile))== "UNREALI.WARLORDROCKET")
		{
			P = spawn(Class 'ExWarlordRocket' ,self,'',Location,AdjustAim(ProjectileSpeed, Location, 400, bLeadTarget, bWarnTarget));
		}
		else
			P = spawn(RangedProjectile ,self,'',projStart,AdjustAim(ProjectileSpeed, projStart, 400, bLeadTarget, bWarnTarget));
		if ( P != None )
			P.DrawScale *= 2;
	}
	else
	{
		G = spawn(class 'Gasbag' ,,'',projStart + (0.6 * CollisionRadius + class'Gasbag'.Default.CollisionRadius) * X);
		if ( G != None )
		{
			G.ParentBag = self;
			numChildren++;
		}
	}
}