class XC_NaliRabbit expands NaliRabbit
	abstract;

function bool TestDirection(vector dir, out vector pick)
{
	local vector HitLocation, HitNormal;
	local actor HitActor;

	HitActor = Trace(HitLocation, HitNormal, Location + dir * 150, Location, false);
	if ( (HitActor != None) && (HitNormal.Z < 0.7) )
	{
		pick = HitLocation - dir + (HitNormal Cross vect(0,0,1)) * 5 * CollisionRadius;
		HitActor = Trace(HitLocation, HitNormal, pick , Location, false);
		if (HitActor != None)
			return false;
	}
	else
		pick = Location + dir * (150 + FRand() * 450);
		return true; 
}

function Tw_PickDestination()
{
	local vector pick, pickdir, enemyDir;
	local bool success;
	local float XY;

	if ( Enemy != None )
		enemyDir = Enemy.Location - Location;
	pickDir = VRand();
	pickDir.Z = 0;
	if ( (pickDir Dot enemyDir) > 0 )
		pickDir *= -1;
	success = TestDirection(pickdir, pick);
	if (!success)
	{
		pickDir = VRand();
		pickDir.Z = 0;
		if ( (pickDir Dot enemyDir) > 0 )
			pickDir *= -1;
		success = TestDirection( pickDir, pick);
	}
	if (success)
		Destination = pick;
	else
	{
		Destination = Location;
		GotoState('Evade', 'Turn');
	}
}