class XC_PlayerPawn expands PlayerPawn abstract;
//class XC_PlayerPawn expands Pawn native nativereplication;

var float LastPathTime;
var bool bSaidPath;

exec function Tw_ShowPath()
{
	local Actor Node;

	CheckPath();
}

final function CheckPath()
{
	local Actor Node;
	local WayBeacon W, W1;
	local bool bHasBeacon;
/*
	if ( !bAdmin && (Level.NetMode != NM_Standalone) )
		return;
*/
	foreach ChildActors(class'WayBeacon',W)
	{
		W1 = W;
		bHasBeacon = True;
		break;
	}
	if ( LastPathTime + 7 > Level.TimeSeconds )
	{
		if ( !bSaidPath )
		{
			bSaidPath = True;
			if ( bHasBeacon )
				W1.Disable('Touch');
			ClientMessage("Spaming is not allowed... Retry after"@(LastPathTime+7)-Level.TimeSeconds@"seconds...");
		}
		GoTo DoNothing;
	}
	else
	{
		if ( bHasBeacon )
			W1.Enable('Touch');
		bSaidPath = False;
		LastPathTime = Level.TimeSeconds;
	}
KeepGoing:
		if ( PointReachable ( Destination ))
		{
			ClientMessage("Destination is Reachable, look around for Lamp-Beacon...");
			if ( bHasBeacon )
			{
				if ( W1.Location != Destination )
					W1.SetLocation(Destination);
			}
			else
				W1 = Spawn(class 'WayBeacon', self, '',Destination);
		}
		else
		{
			Node = FindPathTo(Destination);
			if ( Node != None )
			{
				log(GetHumanName()@"found path: "$Node.Name);
				if ( bHasBeacon )
				{
					if ( W1.Location != Node.Location )
						W1.SetLocation( Node.Location );
				}
				else
					W1 = Spawn(class 'WayBeacon',self,'',Node.location);
				if (W1 != None)
				{
					if ( Node.Base != None )
						W1.SetBase(Node.Base);
					ClientMessage("Path Found - Look For Lamp-Beacon");
				}
			}
			else
			{
				ClientMessage("Could not find a Path to Destination Spot.");
				log(GetHumanName()@"didn't find path.");
			}
		}
DoNothing:
}

//==============
// Prevent clients from slowing down servers and filling their logs
exec function ShowInventory()
{
	local Inventory Inv;

	if ( !bAdmin && (Level.NetMode != NM_Standalone) )
		return;

	if( Weapon!=None )
		log( "   Weapon: " $ Weapon.Class );
	for( Inv=Inventory; Inv!=None; Inv=Inv.Inventory ) 
		log( "Inv: "$Inv $ " state "$Inv.GetStateName());
	if ( SelectedItem != None )
		log( "Selected Item"@SelectedItem@"Charge"@SelectedItem.Charge );
}