class XC_SkaarjBerserker expands SkaarjBerserker
	abstract;

function Tw_WhatToDoNext(name LikelyState, name LikelyLabel)
{
	local Pawn aPawn;

	aPawn = Level.PawnList;
	while ( aPawn != None )
	{
		if ( aPawn != Self && !aPawn.bHidden
			&& aPawn.bCollideActors && aPawn.DrawType == DT_Mesh
			&& aPawn.Mesh != None && LineOfSightTo(aPawn) )
		{
			if ( SetEnemy(aPawn) )
			{
				GotoState('Attacking');
				GoTo NoFurtherAction;
			}
		}
		aPawn = aPawn.nextPawn;
	}
	bQuiet = false;
	Enemy = None;
	if ( OldEnemy != None )
	{
		Enemy = OldEnemy;
		OldEnemy = None;
		GotoState('Attacking');
	}
	else if (Orders == 'Patroling') 
		GotoState('Patroling');
	else if (Orders == 'Guarding')
		GotoState('Guarding');
	else if ( Orders == 'Ambushing' )
		GotoState('Ambushing','FindAmbushSpot');
	else if ( (LikelyState != '') && (FRand() < 0.35) )
		GotoState(LikelyState, LikelyLabel);
	else
		StartRoaming();
NoFurtherAction:
}