class XC_Titan expands Titan
	abstract;

simulated function Tw_SpawnRock()
{
	local Projectile Proj;
	local vector X,Y,Z, projStart;

//	log ("Tw_SpawnRock");
	GetAxes(Rotation,X,Y,Z);
	MakeNoise(1.0);
	if (FRand() < 0.4)
	{
		projStart = Location + CollisionRadius * X + 0.4 * CollisionHeight * Z;
		Proj = spawn(class 'E_Boulder1' ,self,'',projStart,AdjustAim(1000, projStart, 400, false, true));
		if( Proj != None )
			Proj.SetPhysics(PHYS_Projectile);
		return;
	}

	projStart = Location + CollisionRadius * X + 0.4 * CollisionHeight * Z;
	Proj = spawn(class 'E_BigRock' ,self,'',projStart,AdjustAim(1000, projStart, 400, false, true));
	if( Proj != None )
		Proj.SetPhysics(PHYS_Projectile);

	projStart = Location + CollisionRadius * X -  40 * Y + 0.4 * CollisionHeight * Z;
	Proj = spawn(class 'E_BigRock' ,self,'',projStart,AdjustAim(1000, projStart, 400, true, true));
	if( Proj != None )
		Proj.SetPhysics(PHYS_Projectile);

	if (FRand() < 0.2 * skill)
	{
		projStart = Location + CollisionRadius * X + 40 * Y + 0.4 * CollisionHeight * Z;
		Proj = spawn(class 'E_BigRock' ,self,'',projStart,AdjustAim(1000, projStart, 2000, false, true));
		if( Proj != None )
			Proj.SetPhysics(PHYS_Projectile);
	}
}

function Tw_PunchDamageTarget()
{
	if ( Target == None && Enemy != None && Enemy.Health > 0 )
		Target = Enemy;
	if ( Target != None )
	{
		if ( MeleeDamageTarget(PunchDamage, (70000.0 * (Normal(Target.Location - Location)))) )
		{
			PlaySound(Slap, SLOT_Interact);
			PlaySound(Slap, SLOT_Misc);
		}
	}
}

function Tw_SlapDamageTarget()
{
	local vector X,Y,Z;

	if ( Target == None && Enemy != None && Enemy.Health > 0 )
		Target = Enemy;
	if ( Target != None )
	{
		GetAxes(Rotation,X,Y,Z);
		if ( MeleeDamageTarget(SlapDamage, (70000.0 * ( Y + vect(0,0,1)))) )
		{
			PlaySound(Slap, SLOT_Interact);
			PlaySound(Slap, SLOT_Misc);
		}
	}
}
