class XC_Warlord expands Warlord abstract;

simulated function Tw_WPlayRangedAttack()
{
	local vector X,Y,Z, projStart;
	local rotator projRotation;

//	log ("Warlord Ranged");
	if (Physics == PHYS_Flying)
		PlayAnim('FlyFire');
	else
		PlayAnim('Fire');
	GetAxes(Rotation,X,Y,Z);
	projStart = Location - 0.5 * CollisionRadius * Y;
	projRotation = AdjustAim(ProjectileSpeed, projStart, 0, bLeadTarget, bWarnTarget);
//	log ("RangedProjectile ="@RangedProjectile);
	if ( Caps(String(RangedProjectile))== "UNREALI.WARLORDROCKET")
	{
		spawn(Class 'ExWarlordRocket' ,self,'',projStart,projRotation);
//		log ("match");
	}
	else
		spawn(RangedProjectile ,self,'',projStart,projRotation);
}

simulated function Tw_WPlayMovingAttack()
{
	local vector X,Y,Z, projStart;
	local rotator projRotation;

//	log ("Warlord Moving");
	if (Physics == PHYS_Flying)
		PlayAnim('FlyFire');
	else
	{
		DesiredSpeed = 0.4;
		PlayAnim('WalkFire');
	}
	GetAxes(Rotation,X,Y,Z);
	projStart = Location - 0.5 * CollisionHeight * Y;
	projRotation = AdjustAim(ProjectileSpeed, projStart, 600, bLeadTarget, bWarnTarget); 
	if ( FRand() < 0.5 )
	{
		if (FRand() < 0.5)
			projRotation.Yaw += 3072; 
		else
			projRotation.Yaw -= 3072; 
	}
//	log ("RangedProjectile ="@RangedProjectile);
	if ( Caps(String(RangedProjectile))== "UNREALI.WARLORDROCKET")
	{
		spawn(Class 'ExWarlordRocket' ,self,'',projStart,projRotation);
//		log ("match");
	}
	else
		spawn(RangedProjectile ,self,'',projStart,projRotation);
}