class XC_JumpSpot expands JumpSpot
	abstract;

event int SpecialCost(Pawn Seeker)
{
	local Bot B;

	if ( Seeker.PlayerReplicationInfo == None )
		return 100000000;
	B = Bot(Seeker);
	if ( B == None )
	{
		if ( Seeker.FindInventoryType(class 'UT_JumpBoots') != None || Seeker.FindInventoryType(class 'JumpBoots') != None )
			return 5;
		if ( ( Seeker.FindInventoryType(class 'ImpactHammer') != None && Seeker.Health > 90 )
		|| Seeker.FindInventoryType(class 'Translocator') != None )
			return 100;
	}
	else
	{
		if ( B.bCanTranslocate || (B.JumpZ > 1.5 * B.Default.JumpZ) 
			|| (B.Region.Zone.ZoneGravity.Z >= 0.8 * B.Region.Zone.Default.ZoneGravity.Z) )
			return 300;
		if ( bImpactJump && B.bHasImpactHammer && (B.Health > 85) && (!B.bNovice || (B.Skill > 2.5)) 
			&& (B.DamageScaling < 1.4) )
			return 1100;
	}
	return 100000000;
}

function Actor SpecialHandling(Pawn Other)
{
	local Bot B;

	if ( Bot(Other) == None && Other.PlayerReplicationInfo == None )
		return None;

	if (Bot(Other) == None && Other.PlayerReplicationInfo != None)
		return Self;
	if ( (VSize(Location - Other.Location) < 200) 
		 && (Abs(Location.Z - Other.Location.Z) < Other.CollisionHeight) )
		return Self;

	B = Bot(Other);
	if (B != None)
	{
		if ( (Other.JumpZ <= 1.5 * Other.Default.JumpZ) && (B.Region.Zone.ZoneGravity.Z < 0.8 * B.Region.Zone.Default.ZoneGravity.Z) )
		{
			if ( ( B.MyTranslocator == None ) || ( B.MyTranslocator.TTarget != None ) 
				|| ( DeathMatchPlus(Level.Game) != None && !DeathMatchPlus(Level.Game).CanTranslocate(B)) )
			{
				if ( bImpactJump && B.CanImpactJump() )
				{
					PendingBot = B;
					GotoState('PendingImpact');
					Return self;
				}
				return None;
			}
			B.TranslocateToTarget(self);
			return self;
		}
		PendingBot = B;
		GotoState('PendingJump');
		return self;
	}
	return Self;
}