//=============================================================================
// Fake WayBeacon.
//=============================================================================
class XC_WayBeacon expands WayBeacon abstract;

//temporary beacon for serverfind navigation

function PostBeginPlay()
{
	local class<actor> NewClass;

	Super.PostBeginPlay();
	NewClass = class<actor>( DynamicLoadObject( "Unreali.Lamp4", class'Class' ) );
	if( NewClass!=None )
		Mesh = NewClass.Default.Mesh;
}

function Touch(actor other)
{
	local Actor Node;

	if ( Other == Owner )
	{
		LifeSpan = 6.00;
		if ( PlayerPawn(Owner) != None )
		{
			if ( PlayerPawn(Owner).PointReachable( PlayerPawn(Owner).Destination ) )
			{
				if ( Location != PlayerPawn(Owner).Destination )
				{
					PlayerPawn(Owner).ClientMessage("Destination Reachable at"@PlayerPawn(Owner).Destination@"!");
					SetLocation ( PlayerPawn(Owner).Destination );
				}
				else
				{
					PlayerPawn(Owner).ClientMessage("You have reached at Destination!");
					Destroy();
				}
			}
			else
			{
				Node = PlayerPawn(Owner).FindPathTo(PlayerPawn(Owner).Destination);
				if ( Node != None )
				{
					if ( Location != Node.Location )
						SetLocation( Node.Location );
				}
				else
				{
					PlayerPawn(Owner).ClientMessage("No Longer find a path to Destination!");
					Destroy();
				}
			}
		}
	}
}
